/* This file contains the function implementation for safe string copy. */
/* Include guards + includes. */
#ifndef STRZCPY_C
#define STRZCPY_C
/* Include statements. */
#include "strzcpy.h"
#endif //STRZCPY_C

/**
* This function takes a destination buffer, a source buffer and a length.
* Copies the source into the destination, stopping when length is reached or end of destination (whichever is shorter).
* The copied string is always null-terminated when possible (might cause truncation).
* Will return the length copied (and if it overflowed).
*/
char *strzcpy(char *restrict dst, const char* restrict src, size_t len) {
	char *end = memccpy(dst, src, '\0', len);
	if (!end)
		dst[len - 1] = '\0';
	return end;
}
