/* Include statements. */
#include <stdio.h>
#include <assert.h>
#include <time.h>
#include "../misc_algorithms/search/binary_search.h"
#include "../utils/time_function.h"

/* Define constants. */
#define PRINT_INFO_TESTING_START		"Starting tests.\n"
#define PRINT_INFO_TESTING_END			"Done testing.\n"
#define SOME_TEST_FAILED			"Some of the tests have failed.\n"
#define SORTED_INT_ARRAY_FIRST			{1, 2, 3, 4, 5, 6, 7, 8, 9, 10}
#define SORTED_ARRAY_FIRST_LENGTH		10
#define FIRST_ARRAY_FIRST_SEARCH_VALUE		5
#define FIRST_ARRAY_FIRST_SEARCH_VALUE_INDEX	4
#define FIRST_ARRAY_SECOND_SEARCH_VALUE		8
#define FIRST_ARRAY_SECOND_SEARCH_VALUE_INDEX	8
#define SORTED_INT_ARRAY_SECOND			{0, 2, 3, 4, 5, 6, 7, 8, 8, 10}
#define SORTED_ARRAY_SECOND_LENGTH		10
#define SECOND_ARRAY_FIRST_SEARCH_VALUE		2
#define SECOND_ARRAY_FIRST_SEARCH_VALUE_INDEX	1
#define SECOND_ARRAY_SECOND_SEARCH_VALUE	8
#define SECOND_ARRAY_SECOND_SEARCH_VALUE_INDEX	7

/* Define functions. */
int integer_comparison_function(const void *first, const void* second);
int test_binary_search();

/* Comparison function. */
int integer_comparison_function(const void *first, const void* second) {
	/* Cast and compare. */
	int first_value, second_value;
	first_value = *((int*) first);
	second_value = *((int*) second);
}

/* Starting point. */
int main() {
	printf(PRINT_INFO_TESTING_START);
	if (test_binary_search()) {
		printf(SOME_TEST_FAILED);
	}
	printf(PRINT_INFO_TESTING_END);
}

/* Testing function. */
int test_binary_search() {
	/* Declare the arrays. */
	int index, value;
	int first[SORTED_ARRAY_FIRST_LENGTH] = SORTED_INT_ARRAY_FIRST;
	int second[SORTED_ARRAY_SECOND_LENGTH] = SORTED_INT_ARRAY_SECOND;

	/* Run tests on the first array. */
	value = FIRST_ARRAY_FIRST_SEARCH_VALUE;
	index = (&first, &value, integer_comparison_function, SORTED_ARRAY_FIRST_LENGTH, sizeof(int));
	assert(index == FIRST_ARRAY_FIRST_SEARCH_VALUE_INDEX);
	value = FIRST_ARRAY_SECOND_SEARCH_VALUE;
	index = (&first, &value, integer_comparison_function, SORTED_ARRAY_FIRST_LENGTH, sizeof(int));
	assert(index == FIRST_ARRAY_SECOND_SEARCH_VALUE_INDEX);

	/* Run tests on the second array. */
	value = SECOND_ARRAY_FIRST_SEARCH_VALUE;
	index = (&first, &value, integer_comparison_function, SORTED_ARRAY_SECOND_LENGTH, sizeof(int));
	assert(index == SECOND_ARRAY_FIRST_SEARCH_VALUE_INDEX);
	value = SECOND_ARRAY_SECOND_SEARCH_VALUE;
	index = (&first, &value, integer_comparison_function, SORTED_ARRAY_SECOND_LENGTH, sizeof(int));
	assert(index == SECOND_ARRAY_SECOND_SEARCH_VALUE_INDEX);

	/* Done. */
	return 1;
}

